# Build a Minting Component with Mesh

Make sure that you have the [PPBL 2023 Front End Starter](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-2023-front-end-starter) running on your computer at [localhost:3000](http://localhost:3000).

In your local development environment, open the file [/ppbl-2023-front-end-starter/src/pages/minting.tsx](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-2023-front-end-starter/-/blob/main/src/pages/minting.tsx)

<br/>
---

## Going Deeper into Native Scripts

Native Scripts in Cardano Shelley enable multiple parties to authorize transactions with multi signatures, specifying conditions for authorization using JSON-based scripts for payment and delegation.

"Multi-sig" can be used to authorize token minting transactions, allowing multiple parties to jointly create and issue new tokens on the Cardano blockchain. This provides an additional layer of security and decentralization for token minting operations, as multiple parties must agree and sign off on the transaction before it can be executed.

When defining a minting policy with a native script, we use the following kinds of rules:

1. RequireSignature - This script requires a signature of a specific key hash to authorize a transaction (as seen in [Lesson 202.2](/modules/202/2022))

2. RequireAllOf - This script requires signatures from all the listed payment key hashes to authorize a transaction.

3. RequireAnyOf - This script requires at least one signature from the listed payment key hashes to authorize a transaction.

4. RequireMOf - This script requires a certain number (M) of signatures from the listed payment key hashes to authorize a transaction.

5. Timelock: Enforces a time-based condition for spending funds.

### Brain food!

Here a complex example script to think about:

```json
{
  "type": "all",
  "scripts": [
    {
      "type": "atLeast",
      "required": 2,
      "scripts": [
        {
          "type": "sig",
          "keyHash": "d92b712d1882c3b0f75b6f677e0b2cbef4fbc8b8121bb9dde324ff09"
        },
        {
          "type": "sig",
          "keyHash": "4d780ed1bfc88cbd4da3f48de91fe728c3530d662564bf5a284b5321"
        },
        {
          "type": "sig",
          "keyHash": "3a94d6d4e786a3f5d439939cafc0536f6abc324fb8404084d6034bf8"
        }
      ]
    },
    {
      "type": "after",
      "slot": 1234567890
    }
  ]
}
```

This JSON configuration represents a multisig condition where at least 2 out of 3 specific public keys (identified by their key hashes) must sign a transaction, and a timelock condition that requires the transaction to be submitted after a specific time (represented by the slot number) has passed.

In the example below, you will use a simple minting policy. But keep the more complicated example above in mind. What would you need to build in order to use a "multi-sig" script in a minting transaction?

<br/>
---
<br/>

# Step by Step: Minting with Mesh

## Step 1: Get your pubkey hash with Mesh
Mesh provides a `resolvePaymentKeyHash` function that takes an address as input and returns the Public Key Hash associated with that address.

In your local development environment, open the file [/ppbl-2023-front-end-starter/src/pages/minting.tsx](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-2023-front-end-starter/-/blob/main/src/pages/minting.tsx)

You can get your Public Key Hash (aka "pubkey hash") using Mesh. You're going to use `useAddress` and `resolvePaymentKeyHash` to display your address and pubkey hash.

```javascript

// Add these imports at the top of minting.tsx:
import { useAddress, useWallet } from "@meshsdk/react";
import { useEffect, useState } from "react";
import { resolvePaymentKeyHash } from "@meshsdk/core";

.......

export default function Minting() {
  .......
  // Get your address with the address hook and create a state for storing your pubkey
  const address = useAddress();
  const [pubkeyHash, setPubkeyHash] = useState<string>("");

  .......
  // Create useEffect and calculate your pubkey hash
  useEffect(() => {
    if (address) {
      setPubkeyHash(resolvePaymentKeyHash(address));
    }
  }, [address]);

  ......

  // Now display your pubkey hash and address
  return (
    <>
      .......
      <Box
        w={{ base: "100%", md: "90%", lg: "70%" }}
        mx="auto"
        my="5"
        p="5"
        border="1px"
        borderRadius="md"
      >
        <Heading size="md" pb="3">
          Lesson 202.2: Minting a token using Mesh
        </Heading>
        <Text pt="3">My address is {address}</Text>
        <Text pt="3">My pubkey hash is {pubkeyHash}</Text>
      </Box>
      .......
    </>)
}
```

<br/>
---

## Step 2: Create a Minting Form

You need to implement the fields for the minting form. You'll need the name of the token, amount and pubkey hash for the conditional policy.

In this example, we use a library called [Formik](https://formik.org/).

```javascript

// Add these import at the top of your file
import { useFormik } from "formik";

.......

export default function Minting() {
  .......
  // Here you define a basic form handler with Formik
  const formik = useFormik({
    initialValues: {
      pubkeyHash: "",
      amount: 0,
      tokenName: ""
    },
    onSubmit: values => {
      console.log(values)
    }
  })
  ......

  // Now display your pubkey hash and address
  return (
    <>
      .......
        <Text pt="3">My address is {address}</Text>
        <Text pt="3">My pubkey hash is {pubkeyhash}</Text>

        <form onSubmit={formik.handleSubmit}>
          <FormControl>
            <VStack gap={1} alignItems={"start"} mt={4}>
              <FormLabel>Pubkey hash</FormLabel>
              <Input type="text" name="pubkeyHash" value={formik.values.pubkeyHash} onChange={formik.handleChange} />
              <FormHelperText>This needs to be your pubkey hash!</FormHelperText>
              <FormLabel>Token name</FormLabel>
              <Input type="text" name="tokenName" value={formik.values.tokenName} onChange={formik.handleChange} />
              <FormLabel>Amount</FormLabel>
              <Input type="number" name="amount" value={formik.values.amount} onChange={formik.handleChange} />
              <Button type="submit">Mint!</Button>
            </VStack>
          </FormControl>
        </form>
      .......
    </>)
}
```

<br/>
---

## Step 3: Create the Minting Transaction

Finally, you can mint the token in the `handleSubmit` method. This method processes the form data and it is where the blockchain transaction is calculated.

```javascript

// Add these import at the top of your file
import { useWallet } from "@meshsdk/react";
import { AssetMetadata, Mint, Transaction, ForgeScript, NativeScript } from "@meshsdk/core";

.......

export default function Minting() {

  // Get your connected wallet from Mesh
  const { wallet } = useWallet();

  .......
  // Add the formik logic for minting
  const formik = useFormik({
    initialValues: {
      pubkeyHash: "",
      amount: 0,
      tokenName: ""
    },
    onSubmit: async values => {
      if (address === undefined) {
        return;
      }

      // Asset metadata for the minting transaction
      const assetMetadata: AssetMetadata = {
        "name": values.tokenName,
        "description": "Module 202 lesson 2 token minting"
      };

      // Minting parameters
      const asset: Mint = {
        assetName: values.tokenName,
        assetQuantity: values.amount.toString(),
        metadata: assetMetadata,
        label: '721',
        recipient: address
      };

      const tx = new Transaction({initiator: wallet});

      // This is the minting condition. This minting policies is special for the Pubkey Hash specified in the form
      const nativeScript: NativeScript = {
        type: "sig",
        keyHash: values.pubkeyHash
      }
      const forgingScript: ForgeScript = ForgeScript.fromNativeScript(nativeScript);

      // This prepares a transaction with the minting policy and the asset parameters
      tx.mintAsset(
        forgingScript,
        asset,
      );

      // It builds, signs and sends the transaction
      const unSignedTx = await tx.build();
      const signedTx = await wallet.signTx(unSignedTx);

      try {
        await wallet.submitTx(signedTx);
        alert(`${values.amount} ${values.tokenName} are minted! Congratulations!`);
      } catch (err) {
        alert(`Something went wrong!`);
      }

    }
  })
  ......

  // Now display your pubkey hash and address
  return (
      .......
    )
}

```

<br />
---

## Further documentation

You can check the official documentation used in this lessons on the following link [Minting and burning a token with Mesh](https://meshjs.dev/apis/transaction/minting).

<br />
---

## Homework

Now, you know how to work with Mesh and where the documentation is located. You can try to burn your recently minted tokens.

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
